/*
 *   Copyright (C) 2009 by Jonathan Naylor G4KLX
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef	AnalogueRepeaterFrame_H
#define	AnalogueRepeaterFrame_H

#include "AnalogueRepeaterPanel.h"
#include "AnalogueRepeaterDefs.h"

#include <wx/wx.h>

class CAnalogueRepeaterFrame : public wxFrame {
public:
	CAnalogueRepeaterFrame(const wxString& title = wxEmptyString);
	virtual ~CAnalogueRepeaterFrame();

#if defined(__WXDEBUG__)
	virtual void onOpen(wxCommandEvent& event);
#endif
	virtual void onQuit(wxCommandEvent& event);
	virtual void onUpdates(wxCommandEvent& event);
	virtual void onAbout(wxCommandEvent& event);
	virtual void onClose(wxCloseEvent& event);
	virtual void onActions(wxCommandEvent& event);
	virtual void onOutputs(wxCommandEvent& event);
	virtual void onLog(wxEvent& event);

	virtual void onTimer(wxTimerEvent& event);

	virtual void showLog(const wxString& text);

	virtual void setOutputs(bool out1, bool out2, bool out3, bool out4);

private:
	wxTimer                 m_timer;
	CAnalogueRepeaterPanel* m_panel;
	wxMenu*                 m_outputMenu;
	bool                    m_updates;

	DECLARE_EVENT_TABLE()

	wxMenuBar* createMenuBar();
};

#endif
