/*
 *   Copyright (C) 2009,2010 by Jonathan Naylor G4KLX
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef	AnalogueRepeaterConfigAckSet_H
#define	AnalogueRepeaterConfigAckSet_H

#include <wx/wx.h>

#include "CWTextCtrl.h"

class CAnalogueRepeaterConfigAckSet : public wxPanel {
public:
	CAnalogueRepeaterConfigAckSet(wxWindow* parent, int id, const wxString& title, const wxString& radioAck, const wxString& externalAck, unsigned int speed, unsigned int freq, wxFloat32 level, unsigned int delay, unsigned int minimum);
	virtual ~CAnalogueRepeaterConfigAckSet();

	virtual bool Validate();

	virtual wxString     getRadioAck() const;
	virtual wxString     getExternalAck() const;
	virtual unsigned int getSpeed() const;
	virtual unsigned int getFreq() const;
	virtual wxFloat32    getLevel() const;
	virtual unsigned int getDelay() const;
	virtual unsigned int getMinimum() const;

private:
	wxString     m_title;
	CCWTextCtrl* m_radioAck;
	CCWTextCtrl* m_externalAck;
	wxSlider*    m_speed;
	wxSlider*    m_freq;
	wxSlider*    m_level;
	wxSlider*    m_delay;
	wxSlider*    m_minimum;
};

#endif
