/*
 *   Copyright (C) 2009 by Jonathan Naylor G4KLX
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef	NetworkDelay_H
#define	NetworkDelay_H

#include "DStarDefines.h"
#include "HeaderData.h"

#include <wx/wx.h>

struct SNetworkDelayObject {
	NETWORK_TYPE  type;

	CHeaderData*  header;

	unsigned int  length;
	unsigned char data[DV_FRAME_MAX_LENGTH_BYTES];
	bool          end;
};

class CNetworkDelay {
public:
	CNetworkDelay(unsigned int delay);
	virtual ~CNetworkDelay();

	virtual NETWORK_TYPE delay();
	virtual NETWORK_TYPE delay(NETWORK_TYPE type, CHeaderData* header);
	virtual NETWORK_TYPE delay(NETWORK_TYPE type, const unsigned char* data, unsigned int length, bool end);

	virtual CHeaderData* readHeader();
	virtual unsigned int readData(unsigned char* data, unsigned int length, bool& end);

private:
	unsigned int         m_delay;
	unsigned int         m_in;
	unsigned int         m_out;
	SNetworkDelayObject* m_bufList;
};

#endif
