/*
 *   Copyright (C) 2009 by Jonathan Naylor G4KLX
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef	OpenG2ProtocolHander_H
#define	OpenG2ProtocolHander_H

#include "ProtocolHandler.h"
#include "UDPReaderWriter.h"

#include <wx/wx.h>

class COpenG2ProtocolHandler : public IProtocolHandler {
public:
	COpenG2ProtocolHandler(const wxString& gatewayAddress, unsigned int gatewayPort, const wxString& localAddress, unsigned int localPort);
	virtual ~COpenG2ProtocolHandler();

	virtual void setRepeaterCallsign(const wxString& callsign);

	virtual bool open();

	virtual bool writeHeader(const CHeaderData& header);
	virtual bool writeData(const unsigned char* data, unsigned int length, bool end);
	virtual bool writeHeard(const wxString& callsign);
	virtual bool writePoll();

	virtual NETWORK_TYPE read();
	virtual CHeaderData* readHeader();
	virtual unsigned int readData(unsigned char* data, unsigned int length, bool& end);

	virtual void reset();

	virtual void close();

private:
	CUDPReaderWriter m_socket;
	unsigned char*   m_radioCallsign;
	unsigned char*   m_controllerCallsign;
	unsigned char    m_band;
	wxUint16         m_outId;
	wxUint16         m_outSeq1;
	wxUint8          m_outSeq2;
	NETWORK_TYPE     m_type;
	wxUint16         m_inId;
	wxUint16         m_inSeq1;
	wxUint8          m_userSeq2;
	wxUint8          m_statusSeq2;
	unsigned char*   m_buffer;
	unsigned int     m_length;

	bool readPackets();
};

#endif
